**** Include file for TI-85 programs converted with Source Guru

        XDEF    _main
        XDEF    _comment

        XDEF    _ti92plus

_main:
_ti92plus:
        lea     _comment,a6         ; A6 -> start of program
        lea     -8192(sp),sp
        lea     -$6000(sp),a4       ; A4 -> 8K buffer
        move.l  a4,buffer

    IFNE    EXACT_STACK
        move.l  #___byebye-_comment+$9000,d7
    ENDIF
    IFEQ    EXACT_STACK
        moveq   #0,d7
    ENDIF

        jsr     ti85lib@0000
        lea     8192(sp),sp
        rts
buffer: dc.l    0
_comment:

**** Macro to define a label; sets both Z80 and real addresses

__LABEL MACRO
RA_\1   equ     *
\1      equ     RA_\1-_comment+$9000
        ENDM

**** Macro to load an address into A1; compile-time address resolution

__LA    MACRO
___ADDR set     ((\1-$1000)&$7FFF)
    IFGE        ___ADDR-$6000
        move.l  buffer(pc),a1
        add.w   #___ADDR,a1
    ENDIF
    IFLT        ___ADDR-$6000
        lea     _comment+___ADDR(pc),a1
    ENDIF
        ENDM

**** Macro to calculate address Dn into An; run-time address resolution

__ADDR  MACRO

    IFNE    \1-1
        move.w  d\1,d1
    ENDIF

        sub.w   #$1000,d1
        bclr    #15,d1
        cmp.w   #$6000,d1
        bge.s   ib\@

        lea     _comment(pc),a\1
        bra.s   ip\@

ib\@:
        move.l  buffer(pc),a\1

ip\@:
        add.w   d1,a\1
        ENDM

**** Macro to define a constant word (DW directive)

__DW    MACRO
        dc.b    (\1)&$FF
        dc.b    ((\1)&$FF00)>>8
        ENDM

**** Macro to implement LDIR instruction

__LDIR  MACRO
        move.w  sr,d0
        __ADDR  4
        __ADDR  3
        add.w   d2,d4
        add.w   d2,d3
ldi\@:  move.b  (a4)+,(a3)+
        subq.w  #1,d2
        bne.s   ldi\@
        move.b  d0,ccr
        ENDM

**** Macro to implement LDDR instruction

__LDDR  MACRO
        move.w  sr,d0
        __ADDR  4
        __ADDR  3
        sub.w   d2,d4
        sub.w   d2,d3
        cmp.b   (a3)+,(a4)+
ldi\@:  move.b  -(a4),-(a3)
        subq.w  #1,d2
        bne.s   ldi\@
        subq.w  #1,a3
        subq.w  #1,a4
        move.b  d0,ccr
        ENDM

**** Macro to implement LD A,R instruction

__RAND  MACRO
        jsr     ti85lib@000D
        ENDM

**** Macro to implement SRL instruction

__SRL   MACRO
        lsr.b   #1,d\1
        ENDM

**** Macro to implement SLA instruction
        
__SLA   MACRO
        add.b   d\1,d\1
        ENDM

**** Macro to implement RLC instruction

__RLC   MACRO
        rol.b   #1,d\1
        ENDM

**** Macro to implement RRC instruction

__RRC   MACRO
        ror.b   #1,d\1
        ENDM

**** Macro to implement RLCA instruction

__RLCA  MACRO
        rol.b   #1,d7
        ENDM

**** Macro to implement RR instruction

__RR    MACRO
        roxr.b  #1,d\1
        ENDM

**** Macro to implement RRA instruction

__RRA   MACRO
        roxr.b  #1,d7
        ENDM

**** Macro to implement RL instruction

__RL    MACRO
        roxl.b  #1,d\1
        ENDM

**** Macro to implement RRCA instruction

__RRCA  MACRO
        ror.b   #1,d7
        ENDM

**** Macro to implement INC SP instruction

__INCSTACK  MACRO
        bchg    #31,d6
        bne.s   ni\@
        addq.w  #2,a7
ni\@:
        ENDM

**** Macro to implement DEC SP instruction

__DECSTACK  MACRO
        bchg    #31,d6
        beq.s   nd\@
        subq.w  #2,a7
nd\@:
        ENDM

**** Macro to implement stack-exact calls

__JSR   MACRO
        tst.b   $150
        lea     ra\@(pc),a1
        sub.l   #_comment-$9000,a1
        move.w  a1,-(sp)
        jmp     \1
ra\@:
        ENDM

**** Macro to implement stack-exact returns

__RTS   MACRO
        tst.b   $160
        moveq   #0,d0
        move.w  (sp)+,d0
        lea     -$9000+_comment,a1
        jmp     0(a1,d0.l)
        ENDM
